﻿var ntk_RSS_background = {
  xhr:null,
  ntk:null,
  semafor: null,
  getNewRSSBackground: function(clean,  ntk) {
  	var backType = ntk_prf.getInt("backgroundType");
  	if (backType <2)						return;
  	if (ntk_RSS_background.semafor != null)	return;
  	ntk_RSS_background.semafor =1;
  	
	ntk_RSS_background.ntk = ntk;	
	ntk_RSS_background.ntk.showRSSControls(ntk_RSS_background.ntk.CONTROLS_PROGRESS, 100, 1, "");  
    
	if (clean)	{
	    //ntk_RSS_background.ntk.setRSS_BackgroundCur(0);
	    ntk_utils.RSS_BACKGROUND_IMG_ARR = null;
	}
    ntk_RSS_background.xhr = new XMLHttpRequest();
    
	var rss_path = "";

	
	
    if (backType == 2) {
	    try	{
			var mostrecentsearch = ntk_prf.getComplex("mostRecentSearch");
		} catch (e) {	backType =3;	}
    	rss_path = "http://picasaweb.google.com/data/feed/base/all?alt=rss&kind=photo&access=public&filter=1&q=" + mostrecentsearch + "&hl=en_US&imgmax=1440&max-results=250&thumbsize=94";
    }
    
    if (backType == 3) {
    	// Picasa Featured
    	rss_path = "http://picasaweb.google.com/data/feed/base/featured?alt=rss&kind=photo&access=public&hl=en-US&imgmax=1440&max-results=250&thumbsize=94";
    }
    if (backType == 4) {
    	// User search term
    	var term = ntk_prf.getStr("backgroundCommunitySearch");
    	rss_path = "http://picasaweb.google.com/data/feed/base/all?alt=rss&kind=photo&access=public&filter=1&q=" + term + "&imgor=landscape&isvideo=false&hl=en_US&max-results=200&imgmax=1600";				    
	}    	

	if (backType == 5)	{    
		// Specific RSS feed URL
	    try	{ rss_path = ntk_prf.getStr("backgroundRSSURL");	} catch (e)	{}
	    if (rss_path == null || rss_path == "")	return;
    }

    ntk_utils.log("RSS Background ping started: "+rss_path + " -- type:"+backType);
			    
    ntk_RSS_background.xhr.open("GET",rss_path,true);
    ntk_RSS_background.xhr.setRequestHeader("Cache-Control", "no-cache");
    ntk_RSS_background.xhr.setRequestHeader("Pragma", "no-cache");
    ntk_RSS_background.xhr.onreadystatechange = function() {    	
        if (ntk_RSS_background.xhr.readyState == 4)        {
            if (ntk_RSS_background.xhr.status == 200)            {
            	// Good server response...
            	ntk_utils.log("RSS state | status: "+ntk_RSS_background.xhr.readyState+" | " +ntk_RSS_background.xhr.status);
                if (ntk_RSS_background.xhr.responseText != null) {
                    ntk_RSS_background.processRSS(ntk_RSS_background.xhr.responseXML, clean);
                    ntk_RSS_background.xhr = null;
                } else     {
                    ntk_utils.log("Failed to receive RSS file from the server - file not found.");
                    ntk_RSS_background.ntk.showRSSControls(ntk_RSS_background.ntk.CONTROLS_RETRY, 10, 1, "Failed to receive RSS file from the server - check for network connectivity");
                    return false;
                }
            }   else {
            	// Can't get to this server...
            	var msg = ntk_RSS_background.xhr.status;
            	try {
            		msg +=  " received: " + ntk_RSS_background.xhr.statusText;
            	} catch (e)	{}
            	
                ntk_utils.log("Error code " + msg);                                
			    ntk_RSS_background.ntk.showRSSControls(ntk_RSS_background.ntk.CONTROLS_RETRY, 10, 1, "RSS source cannot be reached - check for network connectivity. Error code: "+msg ); 
			}
			 
		 	ntk_RSS_background.semafor = null;

        }
    }

    ntk_RSS_background.xhr.send(null);
	},

  processRSS:function(rssxml, clean)	{
    var imgArr = new Array();
	var Item, enclosure;
    var itemElements = rssxml.getElementsByTagName("item");

    for (var i=0; i<itemElements.length; i++)    {
        Item = itemElements[i];
        // enclosure = ntk_RSS_background.RSS2Enclosure(Item.getElementsByTagName("enclosure")[0]);
		// if (enclosure == null)	
		enclosure = ntk_RSS_background.RSS2Enclosure(Item.getElementsByTagName("media:content")[0]);
        
        if (enclosure != null)	imgArr.push(enclosure);
    }
    ntk_utils.log('processRSS:: done with: '+imgArr.length);
	
    ntk_utils.RSS_BACKGROUND_IMG_ARR = imgArr;
    if (imgArr.length == 0){
		ntk_utils.log("no enclosure imgs...");
		ntk_RSS_background.ntk.showRSSControls(ntk_RSS_background.ntk.CONTROLS_RETRY, 10, 1, "No RSS images enclosed matching the query - retry with another RSS feed address");
		return;		
	}	else	{
		ntk_utils.log("backgroundType | ntk_RSS_background.ntk.getRSS_BackgroundCur() |ntk_RSS_background.ntk.getRSS_BackgroundActive(): "+ntk_prf.getInt("backgroundType")+" | "+ntk_RSS_background.ntk.getRSS_BackgroundCur()+" | "+ntk_RSS_background.ntk.getRSS_BackgroundActive());	
		if (ntk_prf.getInt("backgroundType")>=2 && ntk_RSS_background.ntk.getRSS_BackgroundActive() == ntk_RSS_background.ntk.RSS_ACTIVE) {
	    	ntk_utils.RSS_BACKGROUND_TIMEOUT = setTimeout( function() {ntk_RSS_background.ntk.setRSSBackground(1);}, 10);			    
		}
		
	}
    ntk_RSS_background.ntk.showRSSControls(ntk_RSS_background.ntk.CONTROLS_ACTIVE, 1000, 1, ""); 
        
  }, 
   
  RSS2Enclosure: function (encElement){
    if (encElement == null) {    	return null;    } 
	
	var width = encElement.getAttribute("width");
	var height = encElement.getAttribute("height");
	
	var landscapeOnly = ntk_prf.getBool("BackgroundRSSLandscapeAlign");
	var minRes = ntk_prf.getInt("BackgroundRSSMinRes");


	// ntk_utils.log("RSS2Enclosure: "+width +" | "+height +" | "+landscapeOnly +" | "+minRes  );	

	if (landscapeOnly && height>width)	{		
		return null;
	}
	if (width<minRes)	return null;
	
	return encElement.getAttribute("url");    
  }
}