﻿// new tab king preferences

var ntk_prf = {
	consoleService:Components.classes["@mozilla.org/consoleservice;1"]
                                 .getService(Components.interfaces.nsIConsoleService),
    log: function (aMessage) {
		 	// if(ntk_prf.consoleService)	{ ntk_prf.consoleService.logStringMessage("[NTK] " + aMessage);	}
	},

	srvc: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.ntk."),
	
	getInt: function( name )		{
			try {
				return ntk_prf.srvc.getIntPref(name);
			} catch (e)	{
				ntk_prf.log('Missing INT preference setting (reseting to 0): ' + name)
				ntk_prf.srvc.setIntPref(name,0 );
				return 0;
			}			
		},
	setInt: function( name, val )	{return ntk_prf.srvc.setIntPref(name, val);},
	
	getBool: function( name )			{
			try {
				return ntk_prf.srvc.getBoolPref(name);
			} catch (e)	{
				ntk_prf.log('Missing BOOL preference setting (reseting to true): ' + name)
				ntk_prf.srvc.setBoolPref(name,true );
				return true;
			}						
	},
	setBool: function( name, val ){return ntk_prf.srvc.setBoolPref(name, val);},
	
	getStr: function( name )			{
			try {
				return ntk_prf.srvc.getCharPref(name);
			} catch (e)	{
				ntk_prf.log('Missing CHAR preference setting (reseting to nada): ' + name)
				ntk_prf.srvc.setCharPref(name, "" );
				return "";
			}								
	},
	setStr: function( name, val )	{return ntk_prf.srvc.setCharPref(name, val);},
	
	getComplex: function (name)			{ 
			try {
				return ntk_prf.srvc.getComplexValue(name, Components.interfaces.nsISupportsString).data; 
			} catch (e)	{
				ntk_prf.log('Missing COMPLEX preference setting (reseting to nada): ' + name)
				ntk_prf.setComplex(name, "" );
				return "";
			}								
		
	},
	setComplex: function (name, val) {
		var x = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
	    x.data = val;
	    return ntk_prf.srvc.setComplexValue(name, Components.interfaces.nsISupportsString, x);         	
	},
	
	usrChanged: function( name ){return ntk_prf.srvc.prefHasUserValue(name);},
	
	setDefValIfNotSet:function(key, val)	{
		if (ntk_prf.usrChanged(key)== false)	{
			ntk_prf.setComplex(key, val);
		}		
  	}			
};
